%define section free
%define base_name turbine-jcs
%define jcs_version 1.2.6.5

Summary:        Java Caching System
Name:           jakarta-%{base_name}
Version:        %{jcs_version}
Release:        0.20050611dev.1jpp
Epoch:          0
License:        Apache Software License
URL:            http://jakarta.apache.org/turbine/jcs/
Group:          Development/Libraries
Vendor:         JPackage Project
Distribution:   JPackage
Source0:        http://cvs.apache.org/dist/jakarta/turbine/nightly/jakarta-turbine-jcs/jakarta-turbine-jcs-dev-20050611.tar.gz
Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        jakarta-turbine-jcs-1.2.6.5-jpp-depmap.xml
Patch0:		jakarta-turbine-jcs-project_xml.patch
#Patch0:		jakarta-turbine-jcs-TestUDPDiscovery.patch
BuildRequires:  maven
BuildRequires:  junit
BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:  ant >= 0:1.6
BuildRequires:  saxon, saxon-scripts

BuildRequires:  berkeleydb
BuildRequires:  jakarta-commons-collections
BuildRequires:  jakarta-commons-configuration
BuildRequires:  jakarta-commons-lang
BuildRequires:  jakarta-commons-logging
BuildRequires:  concurrent
BuildRequires:  hsqldb
BuildRequires:  jgroups
BuildRequires:  jisp2
BuildRequires:  log4j
BuildRequires:  servletapi3
BuildRequires:  struts11
BuildRequires:  tomcat3
BuildRequires:  velocity
BuildRequires:  xmlrpc
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-apis

Requires:  /usr/sbin/update-alternatives
Requires:  berkeleydb
Requires:  jakarta-commons-collections
Requires:  jakarta-commons-configuration
Requires:  jakarta-commons-lang
Requires:  jakarta-commons-logging
Requires:  concurrent
Requires:  hsqldb
Requires:  jgroups
Requires:  jisp2
Requires:  log4j
Requires:  servletapi3
Requires:  struts11
Requires:  tomcat3
Requires:  velocity
Requires:  xmlrpc
Requires:  xerces-j2
Requires:  xml-commons-apis
Provides:  hibernate_in_process_cache
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
JCS is a distributed caching system written in java 
for server-side java applications. It is intended to 
speed up dynamic web applications by providing a means 
to manage cached data of various dynamic natures. 
Like any caching system, the JCS is most useful for 
high read, low put applications. Dynamic content and 
reporting systems can benefit most. 
However, any site that repeatedly constructs pages, 
dropdowns, or common search results form a database 
that is updated at intervals (rather than across 
categories continuously) can improve performance and 
scalability by implementing caching. Latency times drop 
sharply and bottlenecks move away from the database in 
an effectively cached system. 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%package manual
Summary:        Docs for %{name}
Group:          Development/Documentation

%description manual
Docs for %{name}.

%prep
%setup -q -n %{name}-dev-20050611
# remove all binary libs
for j in $(find . -name "*.jar"); do
	mv $j $j.no
done

# modify TestUDPDiscovery
# disable TestUDPDiscovery
%patch0 -b .sav

%build
export DEPCAT=$(pwd)/jakarta-turbine-jcs-1.2.6.5-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE2} > jakarta-turbine-jcs-1.2.6.5-depmap.new.xml
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done

for p in $(find . -name project.properties); do
    echo >> $p
    echo maven.repo.remote=file:/usr/share/maven-1.0/repository >> $p
    echo maven.home.local=$(pwd)/.maven >> $p
done

mkdir -p .maven/repository/maven/jars
build-jar-repository .maven/repository/maven/jars maven-jelly-tags

mkdir -p .maven/repository/JPP/jars
build-jar-repository -s -p .maven/repository/JPP/jars \
berkeleydb \
commons-collections \
commons-configuration \
commons-lang \
commons-logging \
concurrent \
hsqldb \
jgroups \
jisp2 \
junit \
log4j \
servletapi3 \
struts-1.1 \
velocity \
xmlrpc \
xerces-j2 \
xml-commons-apis \


pushd .maven/repository/JPP/jars
ln -sf /var/lib/tomcat3/common/tomcat-util.jar tomcat3-util.jar
popd


export MAVEN_HOME_LOCAL=$(pwd)/.maven

maven \
        -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        jar javadoc xdoc:transform ear war

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}
install -m 0644 target/jcs-1.2.6.5.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/ && ln -s %{name}-%{version}.jar %{base_name}-%{version}.jar)
(cd $RPM_BUILD_ROOT%{_javadir}/ && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf target/docs/apidocs

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr target/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

# hibernate_in_process_cache ghost symlink
ln -s %{_sysconfdir}/alternatives \
  $RPM_BUILD_ROOT%{_javadir}/hibernate_in_process_cache.jar

%clean
rm -rf $RPM_BUILD_ROOT

%post
update-alternatives --install %{_javadir}/hibernate_in_process_cache.jar \
  hibernate_in_process_cache %{_javadir}/%{name}.jar 10

%preun
{
  [ $1 -eq 0 ] || exit 0
  update-alternatives --remove hibernate_in_process_cache %{_javadir}/%{name}.jar
} >/dev/null 2>&1 || :


%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}/LICENSE.txt
%{_javadir}/*.jar
%ghost %{_javadir}/hibernate_in_process_cache.jar

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}

%changelog
* Fri Oct 28 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.2.6.5-0.20050611dev.1jpp
- Upgrade to 1.2.6.5
- One test in TestUDPDiscovery failing

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:1.0-0.20031216dev.4jpp
- Rebuild with ant-1.6.2
* Fri Jul 02 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.20031216dev.3jpp
- Relax some versioned dependencies
- provide hibernate_in_process_cache and update-alternatives, prio 10

* Wed Jan 28 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.20031216dev.2jpp
- set dependency to jisp2, instead of jisp

* Wed Jan 28 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.20031216dev.1jpp
- First JPackage release

